<?php
/**
 *@ignore
 */
class KupindoApi {

	protected $serviceUrl 	= "http://arkona.kupindo.com/REST/v1/";
	protected $authorizeUrl = "http://arkona.kupindo.com/Authorize/";
	protected $tokenUrl	 	= "http://arkona.kupindo.com/Token/";
	protected $dataType 	= "json";

	
	function MakeRequest($requestType = "GET", $entity = "", $action = "", $data = array(), $token) {		
		$ch = curl_init();
		try {
			if( isset($data["ID"]) && $data["ID"] > 0 && $requestType == "POST"){
				throw new Exception('Prosledjen ID, uz POST request. Update se radi PUT requestom.');
			}
		} catch (Exception $e) {
			echo $e->getMessage();
			die;
		}
		switch ($requestType) {
			case "PUT":
				$sUrl = $this->GetServiceUrl() . $entity . "." . $this->GetDataType() . "/" . $action;				
				curl_setopt($ch, CURLOPT_URL, $sUrl);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_HTTPHEADER, array('X-HTTP-Method-Override: PUT','Authorization: Bearer ' . $token));
				curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
				break;
			case "POST":
				curl_setopt($ch, CURLOPT_URL, $this->GetServiceUrl() . $entity . "." . $this->GetDataType() . "/" . $action );
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: Bearer ' . $token));
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
				break;
			case "GET":
				curl_setopt($ch, CURLOPT_URL, $this->GetServiceUrl() . $entity . "." . $this->GetDataType() . "/" . $action . "?" . http_build_query($data));				
				curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: Bearer ' . $token));
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				break;
			case "DELETE":
                            $sUrl = $this->GetServiceUrl() . $entity . "." . $this->GetDataType() . "/" . $action;				
				curl_setopt($ch, CURLOPT_URL, $sUrl);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_HTTPHEADER, array('X-HTTP-Method-Override: DELETE','Authorization: Bearer ' . $token));
				curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
				
				break;
		}
		
		$response = curl_exec($ch);
		curl_close($ch);

		if (!$response) {
			return false;
		} else {
			if($this->GetDataType() == "json") {
				$response = json_decode($response);
			}
			return $response;
		}
	}

	function GetServiceUrl() {
		return $this->serviceUrl;
	}

	function GetAuthorizeUrl() {
		return $this->authorizeUrl;
	}

	function GetTokenUrl() {
		return $this->tokenUrl;
	}

	function GetDataType() {
		return $this->dataType;
	}

	function SetDataType($sVrednost) {
		$this->dataType = $sVrednost;
	}
	
	function Authorize($client_id,$state){
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $this->GetAuthorizeUrl() . "?response_type=code&client_id=$client_id&state=$state");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($ch);
		curl_close($ch);
		return $response;
	}
	
	function GetToken($client_id, $code, $password, $redirect_uri){
		$data = array(  "grant_type"=>"authorization_code",
                                "redirect_uri"=>$redirect_uri,
                                "code"=>$code);
		$curl = curl_init();
		                
		curl_setopt($curl, CURLOPT_USERPWD, "$client_id:$password");
		curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($curl, CURLOPT_HEADER, false); 
		curl_setopt($curl, CURLOPT_POST, true); 
		curl_setopt($curl, CURLOPT_URL, $this->GetTokenUrl());
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
		
		$response = curl_exec($curl);
		curl_close($curl);
		
		return $response;
	}
	

	function RefreshToken($client_id, $password, $refresh_token){
		$data = array("grant_type"=>"refresh_token",
						"refresh_token"=>$refresh_token);
		$curl = curl_init();
		
		curl_setopt($curl, CURLOPT_USERPWD, "$client_id:$password");
		curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($curl, CURLOPT_HEADER, false); 
		curl_setopt($curl, CURLOPT_POST, true); 
		curl_setopt($curl, CURLOPT_URL, $this->GetTokenUrl());
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
		
		$response = curl_exec($curl);
		curl_close($curl);
		
		return $response;
	}
        
        function PrepareTokenData($client_id,$client_secret,$redirect_uri){
            
            if( isset($_GET["limundo_data"])){
                $this->SetSessionTokenDataFromGet($client_id,$client_secret);
                header("location: ".$_SERVER['PHP_SELF'] );
                
            }else{
                if( !isset($_SESSION["token_data"]) ){
                    
                    $result = $this->Authorize($client_id,$this->GetState());
                    $result = json_decode($result);
                    $code   = $result->code;

                    $result = $this->GetToken($client_id, $code, $client_secret, $redirect_uri);
                    $result = json_decode($result);
                    $this->SetSessionTokenData($client_id,$client_secret,$result);
                    
                }else if($_SESSION["token_data"]["expires_in"] <= ( time() + 200 ) ){
                    
                    $result = $this->RefreshToken($this->GetSessionClientID(), $this->GetSessionClientSecret(), $this->GetSessionRefreshToken());		
                    $result = json_decode($result);

                    $this->SetSessionTokenData($client_id,$client_secret,$result);
                }
                
            }
            
        }
        
        function SetSessionTokenDataFromGet($client_id,$client_secret){            
            if($this->GetState() == $_GET["state"]){
                $returnData = json_decode( stripslashes($_GET["limundo_data"]));
        
                $_SESSION["token_data"]["client_id"]        = $client_id;
                $_SESSION["token_data"]["client_secret"]    = $client_secret;
                $_SESSION["token_data"]["access_token"]     = $returnData->access_token;
                $_SESSION["token_data"]["refresh_token"]    = $returnData->refresh_token;
                $_SESSION["token_data"]["expires_in"]       = time()+$returnData->expires_in;
                
            }
        }
        
        function SetSessionTokenData($client_id,$client_secret,$data){  
                $_SESSION["token_data"]["client_id"]        = $client_id;
                $_SESSION["token_data"]["client_secret"]    = $client_secret;
                $_SESSION["token_data"]["access_token"]     = $data->access_token;
                if( !isset($_SESSION["token_data"]["refresh_token"]) ){
                	$_SESSION["token_data"]["refresh_token"]    = $data->refresh_token;
                }
                $_SESSION["token_data"]["expires_in"]       = time()+$data->expires_in;
        }
        
        function ResetState(){
             $_SESSION["state"] = rand(1,9999);
        }
        
        function SetState(){
            if( !isset($_SESSION["state"]) ){
                $_SESSION["state"] = rand(1,9999);
            }            
        }
        
        function GetState(){
            return $_SESSION["state"];
        }
        
        function GetSessionClientID(){
            return $_SESSION["token_data"]["client_id"];
        }
        
        function GetSessionClientSecret(){
            return $_SESSION["token_data"]["client_secret"];
        }
        
        function GetSessionAccessToken(){
            return $_SESSION["token_data"]["access_token"];
        }
        
        function GetSessionRefreshToken(){
            return $_SESSION["token_data"]["refresh_token"];
        }
        
        function GetSessionExpiresIn(){
            return $_SESSION["token_data"]["expires_in"];
        }

        function CreateUserTokenUrl($redirect_uri,$client_id){
        	$sUrl = 'http://arkona.kupindo.com/UserLogIn?redirect_uri='.$redirect_uri.'&client_id='.$client_id.'&state='.$this->GetState().'';
        	
        	return $sUrl;
        }
        
        function GetUserTokenUrl(){
        	return $this->userTokenUrl;
        }
}
?>
