<?php
    session_start();

    require_once("KupindoApi.class.php");
    
    $KupindoApi = new KupindoApi();
    
    $KupindoApi->SetState();

    $client_id      = "xxxx-xxxxxxxxx";
    $client_secret  = "xxxxxxxxxxxxxxxxxxxxxxxxxxxx";
    $redirect_uri   = "http://localhost/";

    $KupindoApi->PrepareTokenData($client_id,$client_secret,$redirect_uri);

    $KupindoApi->SetDataType("json");
    
    $category_id = 3;
    if( isset($_GET["category_id"]) ){
        $category_id = intval($_GET["category_id"]);
    }
    
    $data = array(
        "general_parameters"    => array(
                                    "items_per_page"    => 12,
                                    "current_page"      => 1,
                                    "sort_id"           => 2
                                ),
        "return_parameters"     => array(
                                    "article"           => true,
                                    "category"          => false,
                                    "additional_field"  => false,
                                    "article_condition" => false,
                                    "payment_method"    => false,
                                    "shipping_method"   => false,
                                    "region"            => false,
                                    "municipality"      => false
                                ),
        "category_id"           => $category_id
    );
    
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="shortcut icon" href="./favicon.png">

    <title>Kupindo API Pretraga</title>

    <!-- Bootstrap core CSS -->
    <link href="./inc/dist/css/bootstrap.min.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="./inc/offcanvas.css" rel="stylesheet">

    <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="./inc/assets/js/html5shiv.js"></script>
      <script src="./inc/assets/js/respond.min.js"></script>
    <![endif]-->
  </head>

  <body>
    <div class="container">

      <div class="row row-offcanvas row-offcanvas-right">
        <div class="col-xs-12 col-sm-9">
          <p class="pull-right visible-xs">
            <button type="button" class="btn btn-primary btn-xs" data-toggle="offcanvas">Navigacija</button>
          </p>
          <div class="jumbotron">
            <h2>Kupindo API Pretraga</h2>
          </div>
          <div class="row">   
             <?php
                $result = $KupindoApi->MakeRequest("GET", "Search", "", $data, $KupindoApi->GetSessionAccessToken());
    
                if($result->info->response_type==1){
                    foreach($result->array_of_article->article AS $Articles){
                        ?>
                            <div class="col-lg-4">
                                <h4><?php echo $Articles->article_name; ?></h4>
                                <p>
                                    <a target="_blank" href="<?php echo $Articles->article_url; ?>">
                                        <img src="<?php echo $Articles->images->images_m; ?>" alt="<?php echo $Articles->article_name; ?>" />
                                    </a>
                                </p>
                                <p>
                                    <a target="_blank" class="btn btn-danger pull-left" href="<?php echo $Articles->article_url; ?>"><?php echo $Articles->price; ?> RSD</a>
                                    <a target="_blank" class="btn btn-default pull-right" href="<?php echo $Articles->article_url; ?>">Pogledaj &raquo;</a>
                                </p>
                            </div>
                        <?php
                    }
                }
            ?>
          </div><!--/row-->
        </div><!--/span-->

        <div class="col-xs-6 col-sm-3 sidebar-offcanvas" id="sidebar" role="navigation">
          <div class="well sidebar-nav">
            <ul class="nav">
                <?php 
                    $data   = array();
                    $result = $KupindoApi->MakeRequest("GET", "LookUp", "Category", $data, $KupindoApi->GetSessionAccessToken());
                    //var_dump($result);
                    if($result->info->response_type==1){      
                        foreach($result->category AS $Category){
                            if( $Category->category_parent_id > 0 ){
                                continue;
                            }
                            
                            if( $category_id == $Category->category_id  ){
                                ?>
                                    <li class="active">
                                        <span><?php echo $Category->name; ?></span>
                                    </li>
                                <?php
                            }else{
                            ?>
                                <li>
                                    <a href="?category_id=<?php echo $Category->category_id; ?>" ><?php echo $Category->name; ?></a>
                                </li>
                            <?php
                            }                            
                        }
                    }
                ?>
            </ul>
          </div><!--/.well -->
        </div><!--/span-->
      </div><!--/row-->

      <footer>
        <p>&copy; Company <?php echo date("Y"); ?></p>
      </footer>

    </div><!--/.container-->



    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="./inc/assets/js/jquery.js"></script>
    <script src="./inc/dist/js/bootstrap.min.js"></script>
    <script src="./inc/offcanvas.js"></script>
  </body>
</html>
